#include "plugin-openoffice.h"

#define WIDTH_PERCENT 0.8
//======================= CONSTRUCTOR ===================== //
iOO::iOO(void)
{
	m_document = NULL;
}

void iOO::end_plugin(void)
{

}
//====================== LOAD ==============================//
void iOO::load_pdf()
{

	convert_to_pdf();
	string final_name = m_filename.substr(0, m_filename.rfind("."));
	final_name = final_name + ".pdf";
	
	GFile * gfile    = g_file_new_for_path (final_name.c_str () );
	
	//g_debug("New file: %s", final_name.c_str());
	//m_document = poppler_document_new_from_file (g_file_get_uri (gfile), NULL, NULL);
	m_document = poppler_document_new_from_file ("file:///tmp/gloobus_temp.pdf", NULL, NULL);
  	if (m_document == NULL)
	{
    	g_critical("PLUGIN: Error loading PDF\n");
    	exit(-1);
    }

    m_page = poppler_document_get_page (m_document, 0);
    if (m_page == NULL)
	{
		g_critical("PLUGIN: Page not found\n");
		exit(-1);
	}     

	get_scale();
	
	//Delete the temp file
	string cmd = "rm /tmp/gloobus_temp.pdf";
	g_spawn_command_line_sync(cmd.c_str(), NULL, NULL, NULL, NULL);
}
//====================== CONVERT TO PDF =======================//
void iOO::convert_to_pdf	( void )
{

	string cmd = "unoconv --stdout \"" + m_filename + "\" > /tmp/gloobus_temp.pdf";
	//string cmd = "unoconv -f pdf " + m_filename;
	//g_debug("PLUGIN: Converting to PDF [%s]\n",cmd.c_str());
	//g_spawn_command_line_sync(cmd.c_str(), NULL, NULL, NULL, NULL);
	system(cmd.c_str());

}
//====================== GET N PAGES =======================//
int iOO::get_n_pages()
{
	if(m_document == NULL )load_pdf();
	return  poppler_document_get_n_pages(m_document);
}

//====================== GET PAGES WIDTH =======================//
int iOO::get_page_width_unscaled  ( void )
{
    if(m_document == NULL ) load_pdf();
	double x,y;
	poppler_page_get_size (m_page, &x, &y);
	return x;	

}
//====================== GET PAGES HEIGHT =======================//
int	iOO::get_page_height_unscaled ( void )
{
    if(m_document == NULL ) load_pdf();
	double x,y;
	poppler_page_get_size (m_page, &x, &y);
	return y;	
}
//====================== GET PAGES PIXBUF =======================//
GdkPixbuf* iOO::get_page_pixbuf ( int n_page )
{
	GdkPixbuf* temp;
	
	//if(m_document == NULL ) load_pdf();
	//printf("PLUGIN: Loading Page %i\n",n_page);
	m_page 	= poppler_document_get_page 	( m_document, n_page);
	temp 	= gdk_pixbuf_new 	  			( GDK_COLORSPACE_RGB, FALSE, 8, 
											(int)(get_page_width_unscaled() * m_scale), 
											(int)(get_page_height_unscaled() * m_scale));
			  poppler_page_render_to_pixbuf ( m_page,0, 0, 
			  								(int)(get_page_width_unscaled() * m_scale),
			  								(int)(get_page_height_unscaled() * m_scale),
			  								 m_scale,0, temp); 

	return temp;
}

// ====================== GET SCALE ============================== //
void iOO::get_scale ( void )
{
	int x = get_screen_width()-150;
	int y = get_screen_height()-150;

	int x2 = get_page_width_unscaled();
	int y2 = get_page_height_unscaled();

	//g_print("MIDES:%dx%d - %dx%d\n", x,y,x2,y2);

	m_scale = x*WIDTH_PERCENT / x2;

}
// ====================== GET HEIGHT ============================== //
int iOO::get_page_height( void )
{
	//g_print("PAGE HEIGHT SCALED: %d\n",(int)(get_page_height_unscaled() * m_scale));
	//return (int)(get_page_height_unscaled() * m_scale);
	return get_screen_height()-160;
}
// ====================== GET HEIGHT ============================== //
int iOO::get_page_width( void )
{
	//g_print("PAGE WIDTH SCALED: %d\n",(int)(get_page_height_unscaled() * m_scale));
	return (int)(get_page_width_unscaled() * m_scale);
}
