#include "plugin-pdf.h"

#define WIDTH_PERCENT 0.8
//======================= CONSTRUCTOR ===================== //
iPdf::iPdf(void)
{
	m_document = NULL;
}

iPdf::~iPdf(void)
{
	g_print("PLUGIN: Destorying PDF\n");
}

void iPdf::end_plugin(void)
{
	g_debug("PLUGIN: Destroying PDF\n");
}
//====================== LOAD ==============================//
void iPdf::load_pdf()
{
	m_document = poppler_document_new_from_file (g_file_get_uri ( m_gfile), NULL, NULL);
  	if (m_document == NULL)
	{
    	g_critical("PLUGIN: Error loading PDF\n");
    	exit(-1);
    }

    m_page = poppler_document_get_page (m_document, 0);
    if (m_page == NULL)
	{
		g_critical("PLUGIN: Page not found\n");
		exit(-1);
	}     

	//get_scale();
	get_scale2();
}
//====================== GET N PAGES =======================//
int iPdf::get_n_pages()
{
	if(m_document == NULL )load_pdf();
	return  poppler_document_get_n_pages(m_document);
}

//====================== GET PAGES WIDTH =======================//
int iPdf::get_page_width_unscaled  ( void )
{
    if(m_document == NULL ) load_pdf();
	double x,y;
	poppler_page_get_size (m_page, &x, &y);
	return x;	

}
//====================== GET PAGES HEIGHT =======================//
int	iPdf::get_page_height_unscaled ( void )
{
    if(m_document == NULL ) load_pdf();
	double x,y;
	poppler_page_get_size (m_page, &x, &y);
	return y;	
}
//====================== GET PAGE PIXBUF =======================//
GdkPixbuf* iPdf::get_page_pixbuf ( int n_page )
{
	GdkPixbuf* temp;
	
	//if(m_document == NULL ) load_pdf();
	//printf("PLUGIN: Loading Page %i\n",n_page);
	m_page 	= poppler_document_get_page 	( m_document, n_page);
	temp 	= gdk_pixbuf_new 	  			( GDK_COLORSPACE_RGB, FALSE, 8, 
											(int)(get_page_width_unscaled() * m_scale), 
											(int)(get_page_height_unscaled() * m_scale));
			  poppler_page_render_to_pixbuf ( m_page,0, 0, 
			  								(int)(get_page_width_unscaled() * m_scale),
			  								(int)(get_page_height_unscaled() * m_scale),
			  								 m_scale,0, temp); 

	return temp;
}

// ====================== GET SCALE ============================== //
void iPdf::get_scale ( void )
{
	int x = get_screen_width()-150;
	int y = get_screen_height()-150;

	int x2 = get_page_width_unscaled();
	int y2 = get_page_height_unscaled();

	//g_print("MIDES:%dx%d - %dx%d\n", x,y,x2,y2);

	
	if(x2 > x || y2 > y)
	{
		if(x2>y2)
		{
			//g_print("x> PDF SCALE = %f\n",(double)x/x2);
			m_scale = (double)x/x2;
		}
		else
		{
			//g_print("y>PDF SCALE = %f\n",(double)y/y2);
			m_scale = (double)y/y2;
		}
	}
	else
	{
		//g_print("PDF SCALE = 1\n");
		m_scale = 1;
	}
	

}
// ====================== GET SCALE 2============================== //
void iPdf::get_scale2 ( void )
{
	int x = get_screen_width()-150;
	int y = get_screen_height()-150;

	int x2 = get_page_width_unscaled();
	int y2 = get_page_height_unscaled();

	//g_print("MIDES:%dx%d - %dx%d\n", x,y,x2,y2);

	m_scale = x*WIDTH_PERCENT / x2;
	
}
// ====================== GET HEIGHT ============================== //
int iPdf::get_page_height( void )
{
	//g_print("PAGE HEIGHT SCALED: %d\n",(int)(get_page_height_unscaled() * m_scale));
	//return (int)(get_page_height_unscaled() * m_scale);
	return get_screen_height() - 150;
	
}
// ====================== GET HEIGHT ============================== //
int iPdf::get_page_width( void )
{
	//g_print("PAGE WIDTH SCALED: %d\n",(int)(get_page_width_unscaled() * m_scale));
	return (int)(get_page_width_unscaled() * m_scale);
	//return 800;
}
